## ros-foxy-septentrio-gnss-driver 1.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(septentrio_gnss_driver)

## Compile as C++17
add_compile_options(-std=c++17)

## ROS dependencies
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(rosidl_default_generators REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(nmea_msgs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(gps_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_eigen REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)

## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED COMPONENTS system thread regex chrono)
LIST(APPEND CMAKE_MODULE_PATH "/usr/share/cmake/geographiclib")
find_package(GeographicLib REQUIRED)

## For PCAP file handling
find_library(libpcap_LIBRARIES pcap)
if ("${libpcap_LIBRARIES}" STREQUAL "pcap-NOTFOUND")
    set(libpcap_FOUND FALSE)
else ()
    set(libpcap_FOUND TRUE)
endif ()


## Declare  messages
rosidl_generate_interfaces(${PROJECT_NAME}
   "msg/BaseVectorCart.msg"
   "msg/BaseVectorGeod.msg"
   "msg/BlockHeader.msg"
   "msg/MeasEpoch.msg"
   "msg/MeasEpochChannelType1.msg"
   "msg/MeasEpochChannelType2.msg"
   "msg/PVTCartesian.msg"
   "msg/PVTGeodetic.msg"
   "msg/PosCovCartesian.msg"
   "msg/PosCovGeodetic.msg"
   "msg/ReceiverTime.msg"
   "msg/VelCovCartesian.msg"
   "msg/VelCovGeodetic.msg"
   "msg/AttEuler.msg"
   "msg/AttCovEuler.msg"
   "msg/INSNavCart.msg"
   "msg/INSNavGeod.msg"
   "msg/IMUSetup.msg"
   "msg/VectorInfoCart.msg"
   "msg/VectorInfoGeod.msg"
   "msg/VelSensorSetup.msg"
   "msg/ExtSensorMeas.msg"
   DEPENDENCIES std_msgs
)

set(library_name septentrio_gnss_driver_core)
set(executable_name septentrio_gnss_driver_node)

set(dependencies
   rclcpp
   rclcpp_components
   diagnostic_msgs
   nmea_msgs
   sensor_msgs
   geometry_msgs
   gps_msgs
   nav_msgs
   tf2
   tf2_eigen
   tf2_geometry_msgs
   tf2_ros
)

## shared library
add_library(${library_name} SHARED
   src/septentrio_gnss_driver/node/rosaic_node.cpp
   src/septentrio_gnss_driver/communication/circular_buffer.cpp 
   src/septentrio_gnss_driver/parsers/parsing_utilities.cpp 
   src/septentrio_gnss_driver/parsers/string_utilities.cpp 
   src/septentrio_gnss_driver/parsers/nmea_parsers/gpgga.cpp 
   src/septentrio_gnss_driver/parsers/nmea_parsers/gprmc.cpp 
   src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsa.cpp 
   src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsv.cpp 
   src/septentrio_gnss_driver/crc/crc.cpp
   src/septentrio_gnss_driver/communication/communication_core.cpp 
   src/septentrio_gnss_driver/communication/rx_message.cpp 
   src/septentrio_gnss_driver/communication/callback_handlers.cpp
   src/septentrio_gnss_driver/communication/pcap_reader.cpp
)
target_include_directories(${library_name} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"  
  "$<INSTALL_INTERFACE:include>"
)
target_link_libraries(${library_name}
  ${Boost_LIBRARIES}
  pcap
  ${GeographicLib_LIBRARIES}
)
ament_target_dependencies(${library_name}
  ${dependencies}
)

if(${rosidl_cmake_VERSION} VERSION_LESS 2.5.0)
  rosidl_target_interfaces(${library_name}
    ${PROJECT_NAME} "rosidl_typesupport_cpp")
else()
  rosidl_get_typesupport_target(
    cpp_typesupport_target ${PROJECT_NAME} "rosidl_typesupport_cpp")
  target_link_libraries(${library_name} "${cpp_typesupport_target}")
  add_compile_definitions(ROS2_VER_N250)
endif()

## executable
add_executable(${executable_name}
  src/septentrio_gnss_driver/node/main.cpp
)
target_link_libraries(${executable_name}
  ${library_name}
)
ament_target_dependencies(${executable_name}
  ${dependencies}
)

rclcpp_components_register_nodes(${library_name} "rosaic_node::ROSaicNode")

# Enable testing with colcon build --cmake-args -DBUILD_TESTING=ON
#if(BUILD_TESTING)
#  find_package(ament_lint_auto REQUIRED)
#  ament_lint_auto_find_test_dependencies()
#
#  add_subdirectory(test)
#endif()

# Export Targets
ament_export_targets(${library_name} HAS_LIBRARY_TARGET)
ament_export_dependencies(${dependencies} rosidl_default_runtime)

# installation
install(TARGETS
  ${library_name} EXPORT ${library_name}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(TARGETS ${executable_name} EXPORT ${executable_name}
  DESTINATION lib/${PROJECT_NAME}
)

install(DIRECTORY include/
  DESTINATION include/
)

install(DIRECTORY launch
  DESTINATION share/${PROJECT_NAME}
)
install(DIRECTORY config
  DESTINATION share/${PROJECT_NAME}
)

ament_package()

=== debian/changelog ===
ros-foxy-septentrio-gnss-driver (1.2.3-1focal) focal; urgency=high

  * New Features
    
    Twist output option
    
    Example config files for GNSS and INS
    
    Get leap seconds from receiver
    
    Firmware check
    
    VSM from odometry or twist ROS messages
    
    Add receiver type in case INS is used in GNSS mode
    
    Add publishing of base vector topics
  * Improvements
    
    Rework RTK corrections parameters and improve flexibility
  * Fixes
    
    /tf not being published without /localization
    
    Twist covariance matrix of localization
    
    Support 5 ms period for IMU explicitly

 -- Septentrio <githubuser@septentrio.com>  Wed, 09 Nov 2022 00:00:00 -0000

ros-foxy-septentrio-gnss-driver (1.2.2-1focal) focal; urgency=high

  * Fixes
    
    Memory corruption under adverse conditions
  * Commits
    
    Merge pull request #66 from thomasemter/dev/next2
    Fix memory corruption
    
    Fix parameter warnings
    
    Reset buffer size to 16384
    
    Update changelog
    
    Fix memory corruption
    
    Replace maps with unordered_maps
    
    Overload timestamp function
    
    Fix frame ids for INS msgs
    
    Add define to avoid usage of deprecated header
    
    Change readme on gps-msgs packet
    
    Add info on user credentials
    
    Fix spelling in readme
    
    Merge remote-tracking branch 'upstream/ros2' into dev/next2
    
    Add comment for heading from pose
    
    Contributors: Thomas Emter, Tibor Dome

 -- Septentrio <githubuser@septentrio.com>  Tue, 21 Jun 2022 23:00:00 -0000

ros-foxy-septentrio-gnss-driver (1.2.1-1focal) focal; urgency=high

  * New Features
    
    Add login credentials
    
    Activate NTP server if use_gnss_time is set to true
  * Improvements
    
    Add NED option to localization
  * Fixes
    
    IMU orientation for ROS axis convention
  * Commits
    
    Merge pull request #63 from thomasemter/dev/next2
    Small fixes and additions
    
    Merge pull request #60 from wep21/support-rolling
    fix: modify build error for rolling/humble
    
    Revert change for deprecation warning in Humble
    
    Change links to reflect ROS2
    
    Amend readme regarding robot_localization
    
    Fix compiler warnings for humble
    
    Add more explanations for IMU orientation in ROS convention
    
    Fix formatting in readme
    
    Fix package name in readme
    
    Update readme
    
    Update changelog
    
    Fix IMU orientation for ROS axis orientation
    
    Activate NTP only if GNSS time is used
    
    Add NED option to localization
    
    Set NMEA header to GP
    
    Update readme and changelog
    
    Activate NTP server
    
    Add credentials for access control
    
    fix: modify build error for rolling/humble
    
    Contributors: Daisuke Nishimatsu, Thomas Emter, Tibor Dome

 -- Septentrio <githubuser@septentrio.com>  Sun, 15 May 2022 23:00:00 -0000

ros-foxy-septentrio-gnss-driver (1.2.0-1focal) focal; urgency=high

  * New Features
    
    Add option to use ROS axis orientations according to REP103
    
    Add frame_id parameters
    
    Add option to get frames from tf
    
    Publishing of cartesian localization in UTM (topic and/or tf) for INS
    
    Publishing of IMU topic for INS
    
    Publishing of MeasEpoch
    
    ROS2 branch
  * Improvements
    
    Add multi antenna option
    
    Increase number of SBF streams
    
    Add option to set polling_period to "on change"
    
    Increased buffer size from 8192 to 131072 bytes
    
    Add endianess aware parsers
    
    Only publish topics set to true
    
    Add parameter to switch DEBUG logging on and off
    
    Change GPxxx messages to ROS built-in types
    
    Remove duplicate INS msg types
  * Fixes
    
    Setting of antenna type
    
    Publishing rate interconnections of gpsfix and velcovgeodetic
    
    Missing quotes for antenna type
    
    Broken attitude parsing pose and gpsfix from INS
    
    IMU orientation was not sent to Rx
    
    Graceful shutdown of threads
  * Commits
    
    Merge branch 'dev'
    
    Prepare new release
    
    Prepare new release
    
    Merge pull request #53 from thomasemter/dev/refactor
    Very last changes
    
    Add geographic lib dependency to package.xml
    
    Add comment for frame of main antenna
    
    Move utm zone locking section in readme
    
    Reformulate readme section on frames
    
    Merge pull request #52 from thomasemter/dev/refactor
    Last changes
    
    Change frame id back to poi_frame_id
    
    Make error log more explicit
    
    Merge pull request #49 from thomasemter/dev/refactor
    Improve IMU blocks sync and do-not-use value handling
    
    Fix buffer size in changelog
    
    Turn off Nagle's algorithm for TCP
    
    Fix changelog formatting
    
    Fix readme
    
    Set default base frame to base_link
    
    Fix valid tow check logic
    
    Increase buffer size for extreme stress tests
    
    Fix crc check
    
    Fix and streamline tf handling
    
    Add checks for validity of values
    
    Fix rad vs deg
    
    Update changelog
    
    Add some comments
    
    Set stdDevMask to values > 0.0 in node
    
    Set stdDevMask to values > 0.0
    
    Add info on RNDIS and set it to default
    
    Increase default serial baud rate
    
    Add parameter to set log level to debug
    
    Change defaults for publishers in node
    
    Put publish params together and fix mismatch in readme
    
    Improve IMU blocks sync and do-not-use value handling
    
    Merge pull request #48 from thomasemter/dev/refactor
    Fix measepoch not publishing without gpsfix
    
    Fix measepoch not publishing without gpsfix
    
    Merge pull request #47 from thomasemter/dev/refactor
    Dev/refactor
    
    Publish only messages set to true
    
    Remove leftover declaration
    
    Merge branch 'dev/endianess_agnostic' into dev/refactor
    


=== debian/control ===
Source: ros-foxy-septentrio-gnss-driver
Section: misc
Priority: optional
Maintainer: Septentrio <githubuser@septentrio.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libgeographic-dev, libpcap0.8-dev, ros-foxy-ament-cmake, ros-foxy-diagnostic-msgs, ros-foxy-geometry-msgs, ros-foxy-gps-msgs, ros-foxy-nav-msgs, ros-foxy-nmea-msgs, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rosidl-default-generators, ros-foxy-sensor-msgs, ros-foxy-tf2, ros-foxy-tf2-eigen, ros-foxy-tf2-geometry-msgs, ros-foxy-tf2-ros, ros-foxy-ros-workspace, ros-foxy-rosidl-typesupport-fastrtps-c, ros-foxy-rosidl-typesupport-fastrtps-cpp, ros-foxy-rosidl-typesupport-connext-c, ros-foxy-rosidl-typesupport-connext-cpp
Homepage: https://github.com/septentrio-gnss/septentrio_gnss_driver
Standards-Version: 3.9.2

Package: ros-foxy-septentrio-gnss-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libgeographic-dev, libpcap0.8-dev, ros-foxy-diagnostic-msgs, ros-foxy-geometry-msgs, ros-foxy-gps-msgs, ros-foxy-nav-msgs, ros-foxy-nmea-msgs, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rosidl-default-runtime, ros-foxy-sensor-msgs, ros-foxy-tf2, ros-foxy-tf2-eigen, ros-foxy-tf2-geometry-msgs, ros-foxy-tf2-ros, ros-foxy-ros-workspace
Description: ROSaic: C++ driver for Septentrio's mosaic receivers and beyond

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-septentrio-gnss-driver//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
